import { ISharedState, IUseGlobalOptions, Setter, UpdateSpy } from './types';
export declare const curValues: {
    [index: string]: any;
};
export declare const addSharedState: <T>(index: string, f: any) => ISharedState<T>;
export declare const indexErrorMessage = "Unstateless error:  An index is required when using useSharedState directly inside a component.";
export declare const initSharedState: <T>(initialValue: string | T, i?: string | T | undefined) => {
    initial: T;
    index: string;
};
export declare const useGlobal: {
    <T>(options?: IUseGlobalOptions<T> | undefined): (index: string, initialValue: T) => [T, Setter<T>, (newVal: T) => () => void];
    listen: {
        on: <T_1>(state: ISharedState<T_1>, spy: UpdateSpy<T_1>) => void;
        onAll: <T_2>(spy: UpdateSpy<T_2>) => void;
        off: <T_3>(state: ISharedState<T_3>, spy: UpdateSpy<T_3>) => void;
        offAll: <T_4>(spy: UpdateSpy<T_4>) => void;
        clear: <T_5>(state: ISharedState<T_5>) => void;
        clearAll: () => void;
    };
    clear(index: string): void;
    clearAll(): void;
};
